



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>链表的基本操作（Basic Operations on a Linked List）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">链表的基本操作（Basic Operations on a Linked List）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-17 11:45:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>链表可以进行如下操作：</p>
<ul><li>创建新链表</li>
<li>增加新元素</li>
<li>遍历链表</li>
<li>打印链表</li></ul>
<p>下面定义了对应以上操作的基本函数。</p>
<h4>创建新链表</h4>
<p>新链表创建之后里面并没有任何元素，我们要为数据在内存中分配节点，再将节点插入链表。由于这个链表只有一个节点，它所指向的下一个节点为NULL。</p>
<div>
<pre class="prettyprint linenums">/*<br />
Defining a function to create a new list.<br />
The return type of the function is struct node, because we will return the head node<br />
The parameters will be the node, passed from the main function.<br />
The second parameter will be the data element.<br />
*/<br />
struct node * createList(struct node *head,int number)<br />
{<br />
    //creating a temporary node for our initialization purpose<br />
    //the below line allocates a space in memory that can hold the data in a node.<br />
    struct node *temp = (struct node *)malloc(sizeof(struct node));

    //assigning the number to data<br />
    temp -&gt; data = number;

    //assigning the next of this node to NULL, as a new list is formed.<br />
    temp -&gt; next = NULL;

    //now since we have passed head as the parameter, we need to return it.<br />
    head = temp;<br />
    return head;<br />
}</pre>
</div>
<h4>增加新元素</h4>
<p>向链表中增加新元素默认是添加到链表尾部。我们会在以后的内容中讨论添加到链表中间或是开头的情况。</p>
<p>增加一个元素，有两种情况：</p>
<ul><li>链表已经存在，这样我们只要遍历整个链表，然后将新元素添加到链尾就好了。</li>
<li>链表不存在，我们可使用上面的函数创建一个链表。</li></ul>
<h4>遍历链表</h4>
<p>遍历链表很简单，连标的HEAD总是指向链表的第一个元素。如果我们这样做：</p>
<div>
<pre class="prettyprint linenums">HEAD = HEAD -&gt; next;</pre>
</div>
<p>HEAD就向链尾移动了一个节点。</p>
<p>链表的结尾用NULL表示。因此我们只要一直执行这条语句直到遇到NULL，这就意味着完成了遍历。</p>
<div>
<pre class="prettyprint linenums">/*<br />
Defining a case when we need to element in the Linked List.<br />
Here 2 cases can arise:-<br />
    -The Linked List can be empty, then we need to create a new list<br />
    -The Linked List exists, we need to add the element<br />
*/<br />
struct node * addElement(struct node *head, int number)<br />
{<br />
    if(head == NULL)<br />
        head = createList(head, number);   // we can directly call the above function<br />
    else<br />
    {<br />
        // now this is a case when we need to add an element to an existing list.

        //Creating a new node and assigning values<br />
        struct node * temp = (struct node*)malloc(sizeof(struct node));<br />
        temp -&gt; data = number;<br />
        temp -&gt; next = NULL;

        //Now we have created the node but, we need to insert it at the right place.<br />
        //A Linked List terminates when we encounter a NULL<br />
        //Let us traverse the List using another temporary variable.<br />
        //We will point it to the start<br />
        struct node * temp2 = head;

        //The limiting condition of the while loop "until temp2's NEXT is not equal to NULL<br />
        //This will happen only in case of the last node of the list.<br />
        while(temp2 -&gt; next != NULL)<br />
        {<br />
            // We need to go to the next node<br />
            temp2 = temp2 -&gt; next;<br />
        }

        //Now temp2 points at the last node of the list.<br />
        //We can add the node at this position now.

        temp2 -&gt; next = temp;  // the number is added to the end of the List.<br />
    }

    return head; // because we only need the HEAD pointer for a Linked List.<br />
}</pre>
</div>
<h4>打印链表</h4>
<p>和遍历链表相似，区别就在于我们在向链尾移动的同时要打印元素。</p>
<div>
<pre class="prettyprint linenums">/*<br />
A function to print the Linked List.<br />
The return type of this function will be void, as we do not need to return anything.<br />
We just need the HEAD as the parameter, to traverse the Linked List.<br />
*/<br />
void printList(struct node * head)<br />
{<br />
    // The terminating point of a Linked List is defined when we encounter a NULL<br />
    while(head != NULL)<br />
    {<br />
        printf("%d ",head-&gt;data);

        //now we need to move to the next element<br />
        head = head-&gt;next;<br />
    }<br />
}</pre>
</div>
<p>完整的包括main函数的代码已给出：</p>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;stdio.h&gt;<br />
#include&lt;stdlib.h&gt;

//creating the basic structure of a node of a Linked List<br />
struct node<br />
{<br />
    int data;<br />
    struct node * next;<br />
};

/* Defining a function to create a new list.<br />
The return type of the function is struct node, because we will return the head node<br />
The parameters will be the node, passed from the main function.<br />
The second parameter will be the data element.<br />
*/<br />
struct node * createList(struct node *head,int number)<br />
{<br />
    //creating a temporary node for our initialization purpose

    //the below line allocates a space in memory that can hold the data in a node.<br />
    struct node *temp = (struct node *)malloc(sizeof(struct node));

    //assigning the number to data<br />
    temp -&gt; data = number;

    //assigning the next of this node to NULL, as a new list is formed.<br />
    temp -&gt; next = NULL;

    //now since we have passed head as the parameter, we need to return it.<br />
    head = temp;<br />
    return head;<br />
}

/*<br />
Defining a case when we need to element in the Linked List.<br />
Here 2 cases can arise:-<br />
    -The Linked List can be empty, then we need to create a new list<br />
    -The Linked List exists, we need to add the element<br />
*/<br />
struct node * addElement(struct node *head, int number)<br />
{<br />
    if(head == NULL)<br />
        head = createList(head, number);   // we can directly call the above function<br />
    else<br />
    {<br />
        // now this is a case when we need to add an element to an existing list.

        //Creating a new node and assigning values<br />
        struct node * temp = (struct node*)malloc(sizeof(struct node));<br />
        temp -&gt; data = number;<br />
        temp -&gt; next = NULL;

        //Now we have created the node but, we need to insert it at the right place.<br />
        //A Linked List terminates when we encounter a NULL<br />
        //Let us traverse the List using another temporary variable.<br />
        //We will point it to the start<br />
        struct node * temp2 = head;

        //The limiting condition of the while loop "until temp2's NEXT is not equal to NULL<br />
        //This will happen only in case of the last node of the list.<br />
        while(temp2 -&gt; next != NULL)<br />
        {<br />
            // We need to go to the next node<br />
            temp2 = temp2 -&gt; next;<br />
        }

        //Now temp2 points at the last node of the list.<br />
        //We can add the node at this position now.

        temp2 -&gt; next = temp;  // the number is added to the end of the List.<br />
    }

    return head; // because we only need the HEAD pointer for a Linked List.<br />
}

/*<br />
A function to print the Linked List.<br />
The return type of this function will be void, as we do not need to return anything.<br />
We just need the HEAD as the parameter, to traverse the Linked List.<br />
*/<br />
void printList(struct node * head)<br />
{<br />
    // The terminating point of a Linked List is defined when we encounter a NULL<br />
    while(head != NULL)<br />
    {<br />
        printf("%d ",head-&gt;data);

        //now we need to move to the next element<br />
        head = head-&gt;next;<br />
    }<br />
}

//DEFINING THE MAIN FUNCTION

int main(void)<br />
{<br />
    struct node * listHEAD = NULL;

    listHEAD = createList(listHEAD, );  // creating a new List with starting number 42

    //adding a few number to the list<br />
    listHEAD = addElement(listHEAD, );<br />
    listHEAD = addElement(listHEAD, );<br />
    listHEAD = addElement(listHEAD, );

    //finally printing our Linked List<br />
    printList(listHEAD);

    return ;<br />
}</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2wxrlq.html">使用Logstash进行日志分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q25xg3q.html">&lbrack;&period;net 面向对象程序设计进阶&rsqb; &lpar;11&rpar;  序列化&lpar;Serialization&rpar;&lpar;三&rpar;  通过接口 IXmlSerializable 实现XML序列化 及 通用XML类</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqld2309.html">js渐隐渐入渐出效果 fadeOut fadeIn</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rxzre9.html">HTTP权威指南阅读笔记三：HTTP报文</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ez4rx8.html">环信SDK与Apple Watch的结合（3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/49govz7q.html">Effective Java 73 Avoid thread groups</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wdx0wq.html">logstash中的redis插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vvy0n8.html">java中的堆内存和栈内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpmyoq.html">零售POS开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1ol338.html">js操作符</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1x0k59.html">paip&period;hadoop的应用研究总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05d5wq.html">Labeling Balls--poj3687</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljkmvx9.html">CSS浮动专题&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzdokl8.html">Node学习&mdash;&mdash;开篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1l271q.html">DVWA 黑客攻防演练（十）反射型 XSS 攻击 Reflected  Cross Site Scripting</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25jd4lq.html">sql语句case when 以及left&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/960kvpy9.html">java多线程快速入门（十四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o10lm5q.html">kubernetes install for centos</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdvz3z9.html">创建一个版本库，把文件夹用Git管理起来</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj36nr9.html">移动端开发在iOS系统中 new Date&lpar;&rpar; 返回 NaN 的问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93xmoo09.html">C&plus;&plus;基础回顾2（函数&comma; 指针和引用）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v67dj8.html">centos6&period;4安装Vmware exsi CLI</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm6mx19.html">mavne install 报错org&period;apache&period;maven&period;surefire&period;util&period;SurefireReflectionException&colon; java&period;lang&period;reflect&period;InvocationTargetException</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1pj0j8.html">dom4j解析接口使用SOAP传递的xml</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmopx49.html">代码实现Layout android&colon;layout&lowbar;alignParentRight</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdvnve8.html">kvm 启动libvirtd市出现错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm6o109.html">用JS的for循环打印九九乘法表</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1z00m9.html">My way to Python - Day04 - 模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1xm7r9.html">javascriptt切换组件MyTab&period;js封装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mkgzkq.html">jdbc oracle 连接字符串</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
